(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                       DasmReg.TPU                                  
                       -----------                                  
                                                                            
    Liste des segments,offsets,varibles,... pour l'utilitaire 'DesAsm'      
                                                                            
****************************************************************************
******** Pour plus informations consultez le fichier 'DesAsm.txt' **********
****************************************************************************
*)

{-$DEFINE AvecDebut : Commence  lire le programme avec DebutCode }
{$DEFINE EcritJmpPos: Ecrit la position dans le fichier des jumps }

unit DasmReg;

{}
                               {} INTERFACE {}
{}

uses
  Convert,    { Pour l'affichage en hexadcimal }
  DAsmFich,   { Pour la lecture dans le fichier xecutable }
  DasmXms,    { Pour l'cran virtuel (XMS) }
  Xms;        { Pour la mmoire tendue (XMS) }

const
  TxtJmpPos = ';=';
  MovSegTxt = ':[';

  OUI = TRUE;
  NON = FALSE;

  rHaut = OUI;     { Partie haute d'un octet d'un registre   (pour la        }
  rBas  = NON;     { Partie basse d'un octet d'un registre    procdure Reg) }

var Ofs386,Reg386: boolean;

var
  MovSeg: string[2];

(*
               Liste des variables, offsets, immdiates, ... 
              ͼ             *)

{ Liste de tous les registres : AX/CX/DI/ESP/EBX+ESI }
{ NBitsReg = Nombre de bits du registre }
{ Partie : =TRUE  -> Lit le registre dans la partie basse de TmpO (xxxxx111) }
{          =FALSE -> Lit le registre dans la partie haute de TmpO (xx111xxx) }
procedure Reg (NBitsReg: byte; Partie: boolean);

{ Affiche AL/AX/EAX selon NBits (8/16/32) }
procedure AX (NBits: byte);

{ Liste des registres du processeur arithmtique : st(0)/st(2)/st(7) }
procedure RegFPU;

{ Liste des registres de test : TR3,TR4,TR5 }
procedure RegTest;

{ Liste des registres offsets : SI/BX/EAX/ESP }
procedure Ofst;

{ Liste des segments : ES/DS/GS }
procedure Segm;

{ Commentaire pour indiquer le type de variable qui va suivre selon son }
{ nombre de bits (= NBitsVar) }
procedure VarPtr  (NBitsVar: byte);

{ Commentaire pour indiquer le type dplacement qui va suivre selon son }
{ nombre de bits (= NBits) }
procedure JmpPtr (NBits: byte);

{ Commentaire pour indiquer le type dplacement qui va suivre selon son }
{ nombre de bits suivit d'un dollard '$' (= NBits) }
procedure JmpPtrD (NBits: byte);

{ Immdiate non signe (nombre de bits donn par NBitsImm) : 0/1059/156478 }
procedure Imm    (NBitsImm: byte);

{ Immdiate signe (nombre de bits donn par NBitsImm) : -32000/-10/0/1059 }
procedure ImmS   (NBitsImm: byte);

{ Immdiate pour dplacement (nombre de bits donn par NBitsImm et correction
{ d'erreur de dplacement donn par Moins) : -32000/-10/0/1059 }
procedure ImmJmp (NBitsImm: byte; Moins: integer);

{ Nom des cas (conditions) utiliss pour un dplacement (ex: JZ, JE, SETA) }
procedure NomCas;

{ Ecrit une virgule dans la couleur des commentaires }
procedure Virgule;

(*
        Procdure d'affichage d'association de registe/variable/... 
       ͼ      *)

{ Une variable (nombre de bits donn) }
procedure Var_(NBitsVar: byte);

{ Segment:Offset (nombre de bits donn) }
procedure SegOfst (NBitsVar: byte);

{ Offset/Variable/Registre (nombre de bits donn) }
procedure OfsVar (NBits: byte);

{ Segment:Offset[immdiate] (nombre de bits de la variable et de l'immdiate }
{ donn) }
procedure OfsVarImm (NBitsVar,NBitsImm: byte);

{ Registe,Variable/Registre }
procedure RegVar (NBitsReg,NBitsVar: byte);

{ Registe,Immdiate }
procedure RegImm (NBitsReg,NBitsVar: byte);

{ Registe,Segment:Offset/Varible (nombre de bits impos par NBitsReg et }
{ NBitsVar) }
procedure RegVarImpose (NBitsReg,NBitsVar: byte);

{ Registe,Segment }
procedure RegSeg;

{ Varible/Registre,Registe }
procedure VarReg (NBitsReg,NBitsVar: byte);

{ Segment,Registe }
procedure SegReg;

{ Un pointeur (ex: CALL CS:104 }
procedure Pointeur;

{}
                            {} IMPLEMENTATION {}
{}

(*
               Liste des variables, offsets, immdiates, ... 
              ͼ             *)

procedure Reg (NBitsReg: byte; Partie: boolean); var index: byte; begin
  CoulTexte (CoulReg);
  if Partie=rHaut then index := TmpO shr 3 and 7 else index := TmpO and 7;
  if Reg386 or (NBitsReg=32) then begin NBitsReg := 16; EcriM ('E') end;

  Case NBitsReg of
  8:Case index of
    0: EcriM ('AL');
    1: EcriM ('CL');
    2: EcriM ('DL');
    3: EcriM ('BL');
    4: EcriM ('AH');
    5: EcriM ('CH');
    6: EcriM ('DH');
    7: EcriM ('BH');
    end;

  16: Case index of
    0: EcriM ('AX');
    1: EcriM ('CX');
    2: EcriM ('DX');
    3: EcriM ('BX');
    4: EcriM ('SP');
    5: EcriM ('BP');
    6: EcriM ('SI');
    7: EcriM ('DI');
    end;
  end;
end;

procedure AX (NBits: byte); begin
  CoulTexte (CoulReg);
  Case NBits of
    8: EcriM ('AL');
   16: begin if Reg386 then EcriM ('E'); EcriM ('AX') end;
   32: EcriM ('EAX');
  end;
end;

procedure RegFPU; begin
  CoulTexte (CoulReg);
  str (TmpO and 7,txt);
  EcriM ('st('+txt+')');
end;

procedure RegTest; begin
  CoulTexte (CoulReg);
  str (TmpO shr 3 and 7,txt);
  EcriM ('TR'+txt);
end;

procedure Ofst; var TmpO1,SauveTmpO: byte; begin
  CoulTexte (CoulOfst);

  if Ofs386 then
    Case TmpO and 7 of
    0: EcriM ('EAX');
    1: EcriM ('ECX');
    2: EcriM ('EDX');
    3: EcriM ('EBX');
    4: begin
         { Sauve le tampon de fichier }
         SauveTmpO := TmpO;
         move (TamponFich,Tampon.Src^[OfsTamponLibre],SizeOf(TamponFich)); TmpL := FilePos(F);

         { Sauve le nombre de code machine }
         x := CodeMachI;

         { Lit l'octet suivant }
         TmpO1 := TmpO;
         LitO;

         Case TmpO and 7 of
         0: EcriM ('EAX');
         1: EcriM ('ECX');
         2: EcriM ('EDX');
         3: EcriM ('EBX');
         4: EcriM ('ESP');
         5: EcriM ('EBP');
         6: EcriM ('ESI');
         7: EcriM ('EDI');
         end;

         if TmpO and 7<>TmpO shr 3 and 7 then begin
           EcriM ('+');
           Case TmpO shr 3 and 7 of
           0: EcriM ('EAX');
           1: EcriM ('ECX');
           2: EcriM ('EDX');
           3: EcriM ('EBX');
           4: EcriM ('ESP');
           5: EcriM ('EBP');
           6: EcriM ('ESI');
           7: EcriM ('EDI');
           end;
         end else begin
           { Remet les anciennes valeurs si l'octet est inutile }
           move (Tampon.Src^[OfsTamponLibre],TamponFich,SizeOf(TamponFich));
           Seek (F,TmpL);

           { Remet le nombre de code machine }
           CodeMachI :=  X;
         end;

         TmpO := SauveTmpO;
       end;
    5: EcriM ('EBP');
    6: EcriM ('ESI');
    7: EcriM ('EDI');
    end
  else
    Case TmpO and 7 of
    0: EcriM ('BX+SI');
    1: EcriM ('BX+DI');
    2: EcriM ('BP+SI');
    3: EcriM ('BP+DI');
    4: EcriM ('SI');
    5: EcriM ('DI');
    6: EcriM ('BP');
    7: EcriM ('BX');
    end;
end;

procedure Segm; begin
  CoulTexte (CoulSegm);
  Case TmpO shr 3 and 7 of
  0: EcriM ('ES');
  1: EcriM ('CS');
  2: EcriM ('SS');
  3: EcriM ('DS');
  4: EcriM ('FS');
  5: EcriM ('GS');
  else begin
    str (TmpO shr 3 and 7,txt);
    EcriMc ('Segm inconnu = '+txt,CoulInco);
  end end;
end;

procedure VarPtr (NBitsVar: byte); begin
  CoulTexte (CoulComm);

  if Reg386 and ((NBitsVar=16) or (NBitsVar=32)) then NBitsVar := NBitsVar shl 1;

  Case NBitsVar of
    8: EcriM ('byte ');
   16: begin EcriM ('word ') end;
   32: EcriM ('dword ');
   64: EcriM ('qword ');
  128: EcriM ('tbyte ');
  end;
  EcriM ('ptr ');
end;

procedure JmpPtr (NBits: byte); begin
  CoulTexte (CoulComm);
  Case NBits of
    8: EcriM ('short ');
   16: EcriM ('near ptr ');
   32: EcriM ('far ptr ');
  end;
end;

procedure JmpPtrD (NBits: byte); begin
  JmpPtr (NBits);
  EcriM ('$');
end;

procedure Imm (NBitsImm: byte);  begin
  CoulTexte (CoulImm); if (NBitsImm=16) and Reg386 then NBitsImm := 32;
  Case NBitsImm of
    8: begin LitO; EcriM (Hex8(TmpO))  end;
   16: begin LitM; EcriM (Hex16(TmpM)) end;
   32: begin LitL; EcriM (Hex32(TmpL)) end;
  end;
end;

procedure ImmS (NBitsImm: byte);  begin
  CoulTexte (CoulImm); if (NBitsImm=16) and Ofs386 then NBitsImm := 32;
  Case NBitsImm of
    8: begin LitS; if 0<=TmpS then EcriM ('+'); str (TmpS,txt); EcriM (txt) end;
   16: begin LitI; if 0<=TmpI then EcriM ('+'); str (TmpI,txt); EcriM (txt) end;
   32: begin LitL; if 0<=TmpL then EcriM ('+'); str (TmpL,txt); EcriM (txt) end;
  end;
end;

procedure ImmJmp (NBitsImm: byte; Moins: integer);  begin
  CoulTexte (CoulImm); if (NBitsImm=16) and Ofs386 then NBitsImm := 32;
  Case NBitsImm of
   8: begin
    LitS; inc(TmpS,Moins);
    if 0<=TmpS then EcriM ('+');
    Str (TmpS,txt); EcriM (txt);
    {$IFDEF EcritJmpPos}
    Str(PosFich+TamponFich.Pos+TmpS-Moins,txt);
    txt := TxtJmpPos+txt;
    EcriMxc (NbrChAsm-length(txt),EcranY,txt,CoulComm);
    {$ENDIF}
  end;

  16: begin
    LitI; inc(TmpI,Moins);
    if 0<=TmpI then EcriM ('+');
    Str (TmpI,txt); EcriM (txt);
    {$IFDEF EcritJmpPos}
    Str(PosFich+TamponFich.Pos+TmpI-Moins,txt);
    txt := TxtJmpPos+txt;
    EcriMxc (NbrChAsm-length(txt),EcranY,txt,CoulComm);
    {$ENDIF}
  end;

  32: begin
    LitL; inc(TmpL,Moins);
    if 0<=TmpL then EcriM ('+');
    str (TmpL,txt); EcriM (txt);
    {$IFDEF EcritJmpPos}
    Str(PosFich+TamponFich.Pos+TmpL-Moins,txt);
    txt := TxtJmpPos+txt;
    EcriMxc (NbrChAsm-length(txt),EcranY,txt,CoulComm);
    {$ENDIF}
  end end;
end;

procedure NomCas; begin
  Case TmpO and 15 of
  0: EcriM ('O');         { Dbordement (OF=1) }
  1: EcriM ('NO');        { Pas de dbordemant (OF=0) }

  2: EcriM ('B');         { AX <  BX (CF=1) }
  3: EcriM ('AE');        { AX => BX (CF=0) }
  4: EcriM ('Z');  {ou E  : AX =  BX (ZF=1) }
  5: EcriM ('NZ'); {ou NE : AX <> BX (ZF=0) }
  6: EcriM ('BE');        { AX <= BX (CF et ZF=0) }
  7: EcriM ('A');         { AX >  BX (ZF et CF=0) }

  8: EcriM ('S');         { Ngatif (SF=1) }
  9: EcriM ('NS');        { Positif (SF=0) }

  10: EcriM ('P');        { Pair   (PF=1) }
  11: EcriM ('NP');       { Impair (PF=0) }

  12: EcriM ('L');        { AX <  BX (SF <> ZF) }
  13: EcriM ('GE');       { AX >= BX (SF=OF) }
  14: EcriM ('LE');       { AX <= BX (SF<>OF et ZF=1) }
  15: EcriM ('G');        { AX >  BX (ZF et SF=0) }
  end; EcriM (' ');
end;

procedure Virgule; begin
  CoulTexte (CoulComm); EcriM (',');
end;

(*
        Procdure d'affichage d'association de registe/variable/... 
       ͼ      *)

procedure Var_(NBitsVar: byte); var SauveR,SauveO: boolean; begin
  VarPtr (NBitsVar);
  CoulTexte (CoulSegm); EcriM (MovSeg+MovSegTxt);
  SauveR := Reg386; Reg386 := NON;
  SauveO := Ofs386; Ofs386 := NON;
  Imm (16);
  Reg386 := SauveR; Ofs386 := SauveO;
  CoulTexte (CoulSegm); EcriM (']');
end;

procedure SegOfst (NBitsVar: byte); begin
  VarPtr (NBitsVar);

  if (MovSeg='ds') and
  (  (((TmpO and 7=2) or (TmpO and 7=3) or (TmpO and 7=6)) and not Ofs386)
     or ((TmpO and 7=5) and Ofs386)
  ) then MovSeg := 'SS';

  CoulTexte (CoulSegm); EcriM (MovSeg+MovSegTxt);

  Ofst;

  { Seg:[ofst +Imm] ??? }
  if (TmpO shr 6<>0) then begin
    if (TmpO shr 6=1) then NBitsVar := 8 else {TmpO shr 6=2}NBitsVar := 16;
    if (NBitsVar=16) and Ofs386 then NBitsVar := 32;

    ImmS (NBitsVar);
  end;

  CoulTexte (CoulSegm); EcriM (']');
end;

procedure OfsVar (NBits: byte); begin
  if (TmpO shr 6=0) and (TmpO and 7=6) and (not Ofs386) then
    Var_(NBits)
  else
    if TmpO shr 6=1 then SegOfst (NBits) else Reg (Nbits,rBAS);
end;

procedure OfsVarImm (NBitsVar,NBitsImm: byte); begin
  VarPtr (NBitsVar);

  CoulTexte (CoulSegm); EcriM (MovSeg+MovSegTxt);

  Ofst; EcriM (' '); ImmS (NBitsImm);

  CoulTexte (CoulSegm); EcriM (']');
end;

procedure RegVar (NBitsReg,NBitsVar: byte); begin
  LitO;
  Reg (NbitsReg,rHAUT);
  Virgule;
  OfsVar (NBitsVar);
end;

procedure RegImm (NBitsReg,NBitsVar: byte); begin
  Reg (NBitsReg,rBAS);
  Virgule;
  Imm (NBitsVar);
end;

procedure RegVarImpose (NBitsReg,NBitsVar: byte); begin
  LitO;
  Reg (NbitsReg,rHAUT);
  Virgule;
  if (NBitsVar=16) and Reg386 then Reg386 := NON;
  OfsVar (NBitsVar);
end;

procedure RegSeg; begin
  LitO;
  OfsVar (16);
  Virgule;
  Segm;
end;

procedure VarReg (NBitsReg,NBitsVar: byte); begin
  LitO;
  OfsVar (NBitsVar);
  Virgule;
  Reg (NbitsReg,rHAUT);
end;

procedure SegReg; begin
  LitO;
  Segm;
  Virgule;
  OfsVar (16);
end;

procedure Pointeur; var Segm,Ofst: word; begin
  LitM; ofst := TmpM; LitM; segm := TmpM;
  str (LongInt(segm) shl 4 +ofst,txt);
  EcriMc ('CS:',CoulSegm);
  EcriMc (txt,CoulImm);
  str (PosDebutCode +LongInt(segm) shl 4 +ofst,txt);
  txt := TxtJmpPos +txt;
  EcriMxc (NbrChAsm-length(txt),EcranY,txt,CoulComm);
end;

{}
{                           CHARGEMENT DE L'UNITE                          }
{}

begin
  { Rien pour le dmarrage }
end.